=== examples/Python/CMakeLists.txt ===
file(GLOB PY_BASIC_TUTORIAL_FILES "Basic/*.py")
source_group("Basic" FILES ${PY_BASIC_TUTORIAL_FILES})
file(GLOB PY_ADVANCED_TUTORIAL_FILES "Advanced/*.py")
source_group("Advanced" FILES ${PY_ADVANCED_TUTORIAL_FILES})
file(GLOB PY_MISC_TUTORIAL_FILES "Misc/*.py")
source_group("Misc" FILES ${PY_MISC_TUTORIAL_FILES})
file(GLOB PY_BENCHMARK_TUTORIAL_FILES "Benchmark/*.py")
source_group("Benchmark" FILES ${PY_BENCHMARK_TUTORIAL_FILES})
file(GLOB PY_RECONSTRUCTION_SYSTEM_TUTORIAL_FILES "ReconstructionSystem/*.py")
source_group("ReconstructionSystem" FILES ${PY_RECONSTRUCTION_SYSTEM_TUTORIAL_FILES})
add_custom_target(Python ALL SOURCES ${PY_BASIC_TUTORIAL_FILES} ${PY_ADVANCED_TUTORIAL_FILES} ${PY_MISC_TUTORIAL_FILES} ${PY_BENCHMARK_TUTORIAL_FILES} ${PY_RECONSTRUCTION_SYSTEM_TUTORIAL_FILES})
set_target_properties(Python PROPERTIES FOLDER "examples/")
