=== src/Python/requirements.txt ===
ipywidgets
widgetsnbextension
notebook
numpy
