=== debian/control ===
Source: open3d
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Timo Röhling <timo@gaussglocke.de>, Jochen Sprickerhof <jspricke@debian.org>
Build-Depends: debhelper-compat (= 13),
    cmake, pkg-kde-tools,
    libeigen3-dev,
    libflann-dev,
    libfmt-dev (>= 5),
    liblzf-dev,
    libglew-dev,
    libglfw3-dev,
    libjpeg-dev,
    libjsoncpp-dev,
    libpng-dev,
    libqhull-dev (>= 2019.1),
    libtinygltf-dev,
    libtinyobjloader-dev,
    dh-python, python3-all-dev, python3-setuptools, pybind11-dev (>= 2.2),
    googletest <!nocheck>,
    doxygen <!nodoc>,
    jdupes <!nodoc>,
    python3-sphinx <!nodoc>, python3-sphinx-rtd-theme <!nodoc>, python3-numpy <!nodoc>
Homepage: http://www.open3d.org
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/science-team/open3d.git
Vcs-Browser: https://salsa.debian.org/science-team/open3d

Package: libopen3d-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libopen3d0d (= ${binary:Version}),
         libeigen3-dev, libfmt-dev, libglew-dev, libglfw3-dev,
         ${misc:Depends}
Suggests: open3d-doc
Description: Library for 3D data processing - development headers
 Open3D is an open-source library that supports rapid development of
 software that deals with 3D data. The Open3D frontend exposes a set
 of carefully selected data structures and algorithms in both C++ and
 Python. The backend is highly optimized and is set up for parallelization.
 .
 This package contains the development headers for C++

Package: libopen3d0d
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for 3D data processing
 Open3D is an open-source library that supports rapid development of
 software that deals with 3D data. The Open3D frontend exposes a set
 of carefully selected data structures and algorithms in both C++ and
 Python. The backend is highly optimized and is set up for parallelization.

Package: python3-open3d
Section: python
Architecture: any
Provides: ${python3:Provides}
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: open3d-doc
Description: Library for 3D data processing - Python 3 bindings
 Open3D is an open-source library that supports rapid development of
 software that deals with 3D data. The Open3D frontend exposes a set
 of carefully selected data structures and algorithms in both C++ and
 Python. The backend is highly optimized and is set up for parallelization.
 .
 This package provides the Python 3 bindings for Open3D.

Package: open3d-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: Library for 3D data processing - API Documentation
 Open3D is an open-source library that supports rapid development of
 software that deals with 3D data. The Open3D frontend exposes a set
 of carefully selected data structures and algorithms in both C++ and
 Python. The backend is highly optimized and is set up for parallelization.
 .
 This package provides the API documentation.
